//--------------------------
//
//CRONOTERMOSTATO
//PROGRAMMABILE
//TPZ47
//
//by TECNOVOLT (tecnovolt.altervista.org)
//
//data: febbraio 2012
//
//copyright (c) 2012-2106
//
//--------------------------

#define  XTAL_FREQ 20MHZ
#include <pic.h>


__CONFIG (FOSC_HS & WDTE_OFF & PWRTE_ON & BOREN_OFF & LVP_OFF & CPD_OFF & WRT_OFF & DEBUG_OFF & CP_OFF);


#include "delay.c" 
#include "lcd.c"



unsigned char secondi;		//var uscita dall'interrupt sul timer0 (ISR)
unsigned char minuti;		//var uscita dall'interrupt sul timer0 (ISR)
unsigned char ore;			//var uscita dall'interrupt sul timer0 (ISR)
unsigned char giorni = 1;	//var uscita dall'interrupt sul timer0 (ISR)
unsigned int secondiint;	//var contenente il valore intero dei secondi
unsigned int minutiint;		//var contenente il valore intero dei minuti
unsigned int oreint;		//var contenente il valore intero delle ore
unsigned int giorniint;		//var contenente il valore intero dei giorni
unsigned int orariotemp[4];	//array contenete il valore temporaneo dell'orario mentre si imposta
int ctrlbt1 = 0;			//interno - controllo bt1
int ctrlbt2 = 0;			//interno - controllo bt2
int ctrlbt3 = 0;			//interno - controllo bt3
int ctrlbt4 = 0;			//interno - controllo bt4
int bt1press = 0;			//attivazione BT1
int bt2press = 0;			//attivazione BT2
int bt3press = 0;			//attivazione BT3
int bt4press = 0;			//attivazione BT4
int valoread = 0;			//interno - valore dell'ADC
int tempamb = 0;			//temperatura ambientale
int ctrladc = 0;			//interno - controllo ADC
int menucorr = 1;			//MENU corrente
int timp = 20;				//temperatura impostata
int tmin = 19;				//temperatura minima
int tmax = 21;				//temperatura massima
int stato = 0;				//stato impianto (0 spento; 1 acceso)
int timer = 0;				//stato timer (on/off)
int termostato = 0;			//stato termostato (on/off)
int ctrlmn41 = 1;			//var ctrl del menu 4.1
int ctrlmn41bis = 1;		//var ctrl selezioni sottomenu programmi (giorni, ore, temp)
int ctrlmn411 = 1;			//var ctrl selezione giorni
int ctrlmn412 = 1;			//var ctrl selezione orario
int ctrlmn51 = 1;			//var ctrl selezione regolazione data-ora
int ctrlmn51bis = 0;		//var ctrl menu51
int i = 1;					//var controllo per gli array
int h = 1;					//var controllo per gli array
int giorniatt[8][5];		//array contenente i giorni attivi dei 4 programmi (array 2D)
int orari[5][5];			//array contenente gli orari di accensione e spegnimento dei 4 programmi (array 2D)
int temperature[5];			//array contenente le temperature dei 4 programmi (array 1D)
int retrosec=0;				//var per il controllo della retroilluminazione (secondi)
int varsecg[5]=1;			//varsec : variabili per aumentare/diminuire lo scarto dei secondi dovuto alle tolleranze del quarzo
int ctrlmn6=1;				//var controllo selezione menu 6
int ctrlsecgvar=1;			//var controllo per la somma dei varsecg al valore dei secondi
int menopius=0;				//var controllo di varsecg (0 = sottrae varsecg ai secondi / 1 = somma varsecg ai secondi)
int ctrlmn62=1;

void main(void)
	{

	ADCON0=0b10000001;
    ADCON1=0b10001110;
	TRISA=0b00000001;
	TRISB=0b11111001;
	TRISC=0b00000000;
	TRISD=0b00000000; 
	TRISE=0b00000000;
	OPTION_REG=0b00000000;
TMR1H=0x80;
TMR1L=0x00;
GIE=1; // gestione globale interrupt attiva
PEIE=1; // interrupt di periferica abilitati
TMR1IE=1; // interrupt su overflow timer1 abilitato
T1CON=0b00001111;
/*
bit 7 e 6 : non usati
bit 5 e 4 (T1CKPS1:T1CKPS0): 00 - Prescaler impostato a 1:1
bit 3 (T1OSCEN): 1 - circuito di oscillazione abilitato
bit 2 (T1SYNC): 1 - timer1 in modalit asincrona
bit 1 (TMR1CS): 1 - timer1 impostato per usare oscillatore esterno
bit 0 (TMR1ON): 1 - timer1 abilitato
*/
	

	LCD_INIT();
	DelayMs(100);
	LCD_CLEAR();



i=1;
for(i=1;i>7;i++){
	giorniatt[i][1]=0;
}
i=1;
for(i=1;i>7;i++){
	giorniatt[i][2]=0;
}
i=1;
for(i=1;i>7;i++){
	giorniatt[i][3]=0;
}
i=1;
for(i=1;i>7;i++){
	giorniatt[i][4]=0;
}
i=1;

for(i=1;i>4;i++){
	orari[i][1]=0;
}
i=1;
for(i=1;i>4;i++){
	orari[i][2]=0;
}
i=1;
for(i=1;i>4;i++){
	orari[i][3]=0;
}
i=1;
for(i=1;i>4;i++){
	orari[i][4]=0;
}
i=1;
for(i=1;i>4;i++){
	temperature[i]=20;
}
i=1;
varsecg[1]=1;
varsecg[2]=1;
varsecg[3]=2;
varsecg[4]=2;

//-------------------------------------------------------------------------INIZIO SUPERCICLO WHILE

	while(1)
        {

DelayMs(25);		//ATTESA tra un ciclo e il successivo

LCD_CLEAR();

//----------INIZIO CONTROLLO PULSANTI----------

//btXpress = se il pulsante X  stato premuto va a 1, altrimenti rimane a 0
//			dopo ogni operazione di verifica su questa variabile, deve essere riportata a 0


//--BT1
		if(RB7==0){
			if(ctrlbt1==0){
				ctrlbt1=1;
			}		
		}

		DelayMs(1);

		if(ctrlbt1==1){
			if(RB7==1){
				bt1press=1;
				ctrlbt1=0;
			}
		}



//--BT2
		if(RB6==0){
			if(ctrlbt2==0){
				ctrlbt2=1;
			}		
		}

		DelayMs(1);

		if(ctrlbt2==1){
			if(RB6==1){
				bt2press=1;
				ctrlbt2=0;
			}
		}


//--BT3
		if(RB5==0){
			if(ctrlbt3==0){
				ctrlbt3=1;
			}		
		}

		DelayMs(1);

		if(ctrlbt3==1){
			if(RB5==1){
				bt3press=1;
				ctrlbt3=0;
			}
		}


//--BT4
		if(RB4==0){
			if(ctrlbt4==0){
				ctrlbt4=1;
			}		
		}

		DelayMs(1);

		if(ctrlbt4==1){
			if(RB4==1){
				bt4press=1;
				ctrlbt4=0;
			}
		}


//----------FINE CONTROLLO PULSANTI----------

//----------CONTROLLO RETROILLIMINAZIONE

if(bt1press==1){
	retrosec=0;
}
if(bt2press==1){
	retrosec=0;
}
if(bt3press==1){
	retrosec=0;
}
if(bt4press==1){
	retrosec=0;
}

if(retrosec<30){
	RB1=1;
	RB2=1;
} else {
	RB1=0;
	RB2=0;
	menucorr=1;
}
	

//----------FINE CTRL RETROILLUMINAZIONE

//----------CONTROLLO TEMPERATURA

if(ctrladc==0){
	GO = 1;
	ctrladc=1;
}


if(GO==0){
    valoread=ADRESL + (ADRESH<<8);
	tempamb=((valoread*5)/10);			
	ctrladc=0;
}

//---------------------------------------------CONVERSIONE ORARIO

secondiint=secondi;
minutiint=minuti;
oreint=ore;
giorniint=giorni;


//---------------------------------------------FINE CONVERSIONE ORARIO

//------------------------------------------------INIZIO CONTROLLO ORARI E CONFRONTO CON PROGRAMMI


if(timer==1){
	i=1;
	for(i=1;i<5;i++){		//-------------------------ORARI INIZIO
		if(giorniatt[giorniint][i]==1){
			if(orari[1][i]==oreint){
				if(orari[2][i]==minutiint){
					if(secondiint==1){
						termostato=1;
						timp=temperature[i];
					}
				}
			}
		}
	}
	

	i=1;
	for(i=1;i<5;i++){		//------------------------ORARI FINE
		if(giorniatt[giorniint][i]==1){
			if(orari[3][i]==oreint){
				if(orari[4][i]==minutiint){
					if(secondiint==1){
						termostato=0;
					}
				}
			}
		}
	}
	i=1;
}

//------------------------------------------------FINE CONTROLLI ORARI

//------------------------------------------------TERMOSTATO
tmin=timp-1;
tmax=timp+1;
if(termostato==1){
	if(tempamb<=tmin){
		stato=1;
	}
	if(tempamb>=tmax){
		stato=0;
	}
}
if(termostato==0){
	stato=0;
}
//------------------------------------------------FINE TERMOSTATO

if(stato==1){		//attivazione rel carico se stato=1
	RA1=1;
} else {
	RA1=0;
}

//------------------------------------------------MENU 1 (schermata iniziale)

if (menucorr==1){
	LCD_PUTUN(tempamb);
	LCD_GOTO(1,3);
	LCD_PUTS("C[");
	LCD_PUTUN(timp);
	LCD_PUTS("]");
	if(stato==1){
		LCD_PUTS("ON");
	} else {
		LCD_PUTS("OFF");
	}
	LCD_GOTO(1,12);
	if(oreint<=9){
		LCD_PUTS("0");
	}
	LCD_PUTUN(oreint);
	LCD_PUTS(":");
	if(minutiint<=9){
		LCD_PUTS("0");
	}
	LCD_PUTUN(minutiint);
	LCD_GOTO(2,14);
	switch(giorniint){
	case 1:
		LCD_PUTS("Lun");
		break;
	case 2:
		LCD_PUTS("Mar");
		break;
	case 3:
		LCD_PUTS("Mer");
		break;
	case 4:
		LCD_PUTS("Gio");
		break;
	case 5:
		LCD_PUTS("Ven");
		break;
	case 6:
		LCD_PUTS("Sab");
		break;
	case 7:
		LCD_PUTS("Dom");
		break;
	}

	LCD_GOTO(2,1);
	if(termostato==1){
		LCD_PUTS("TRS");
	} else {
		LCD_PUTS("---");
	}
	LCD_PUTS("|");
	if(timer==1){
		LCD_PUTS("TMR");
	} else {
		LCD_PUTS("---");
	}

	if(bt1press==1){
		menucorr=2;
		bt1press=0;
	}

	bt2press=0;

	if(bt3press==1){
		if(timp<50){
			timp++;
		}
		bt3press=0;
	}
	if(bt4press==1){
		if(timp>5){
			timp--;
		}
		bt4press=0;
	}
}


//------------------------------------------------MENU 2 (on/off TIMER)

if(menucorr==2){
	LCD_PUTS(" menu principale");
	LCD_GOTO(2,3);
	LCD_PUTS("timer ");
	if(timer==1){
		LCD_PUTS("attivo");
	} else {
		LCD_PUTS("spento");
	}
	if(bt1press==1){
		timer=timer^1;
		bt1press=0;
	}
	if(bt2press==1){
		menucorr=1;
		bt2press=0;
	}
	bt3press=0;
	if(bt4press==1){
		menucorr=3;
		bt4press=0;
	}
}
//------------------------------------------------MENU 3 (on/off TERMOSTATO)

if(menucorr==3){
	LCD_PUTS(" menu principale");
	LCD_GOTO(2,1);
	LCD_PUTS("termostato ");
	if(termostato==1){
		LCD_PUTS("attivo");
	} else {
		LCD_PUTS("spento");
	}
	if(bt1press==1){
		termostato=termostato^1;
		bt1press=0;
	}
	if(bt2press==1){
		menucorr=1;
		bt2press=0;
	}
	if(bt3press==1){
		menucorr=2;
		bt3press=0;
	}
	if(bt4press==1){
		menucorr=4;
		bt4press=0;
	}
}
//------------------------------------------------MENU 4 (programmazione timer)

if(menucorr==4){
	LCD_PUTS(" menu principale");
	LCD_GOTO(2,1);
	LCD_PUTS("  prog timer");
	if(bt1press==1){
		menucorr=41;
		bt1press=0;
	}
	if(bt2press==1){
		menucorr=1;
		bt2press=0;
	}
	if(bt3press==1){
		menucorr=3;
		bt3press=0;
	}
	if(bt4press==1){
		menucorr=5;
		bt4press=0;
	}
}
//------------------------------------------------MENU 4.1 (scelta programma)
if(menucorr==41){
	LCD_PUTS("  prog. timer");
	LCD_GOTO(2,2);
	LCD_PUTS("programma ");
	LCD_PUTUN(ctrlmn41);
	if(bt1press==1){
		menucorr=411;
		bt1press=0;
	}
	if(bt2press==1){
		menucorr=4;
		bt2press=0;
	}
	if(bt3press==1){
		ctrlmn41++;
		bt3press=0;
	}
	if(bt4press==1){
		ctrlmn41--;
		bt4press=0;
	}
	if(ctrlmn41>4){
		ctrlmn41=1;
	}
	if(ctrlmn41<1){
		ctrlmn41=4;
	}
}
//------------------------------------------------MENU 4.1.1
if(menucorr==411){
	LCD_PUTS(" programma ");
	LCD_PUTUN(ctrlmn41);
	LCD_GOTO(2,1);
	switch(ctrlmn41bis){
		case 1:
		LCD_PUTS(" giorni attivi");
		break;
		case 2:
		LCD_PUTS("     orari");
		break;
		case 3:
		LCD_PUTS("  temperatura");
		break;
	}
	if(bt1press==1){
		switch(ctrlmn41bis){
			case 1:
			menucorr=4111;
			break;
			case 2:
			menucorr=4121;
			break;
			case 3:
			menucorr=4131;
			break;
		}
		bt1press=0;
	}
	if(bt2press==1){
		menucorr=41;
		bt2press=0;
	}
	if(bt3press==1){
		ctrlmn41bis--;
		bt3press=0;
	}
	if(bt4press==1){
		ctrlmn41bis++;
		bt4press=0;
	}
	if(ctrlmn41bis>3){
		ctrlmn41bis=1;
	}
	if(ctrlmn41bis<1){
		ctrlmn41bis=3;
	}
}

//------------------------------------------------MENU 4.1.1.1 (prog. GIORNI)
if(menucorr==4111){
	LCD_GOTO(1,2);
	LCD_PUTUN(giorniatt[1][ctrlmn41]);
	LCD_GOTO(1,4);
	LCD_PUTUN(giorniatt[2][ctrlmn41]);
	LCD_GOTO(1,6);
	LCD_PUTUN(giorniatt[3][ctrlmn41]);
	LCD_GOTO(1,8);
	LCD_PUTUN(giorniatt[4][ctrlmn41]);
	LCD_GOTO(1,10);
	LCD_PUTUN(giorniatt[5][ctrlmn41]);
	LCD_GOTO(1,12);
	LCD_PUTUN(giorniatt[6][ctrlmn41]);
	LCD_GOTO(1,14);
	LCD_PUTUN(giorniatt[7][ctrlmn41]);
	LCD_GOTO(2,1);
	LCD_PUTS(" L M M G V S D ");
	LCD_GOTO(2,(ctrlmn411*2)-1);
	LCD_PUTS("[");
	LCD_GOTO(2,(ctrlmn411*2)+1);
	LCD_PUTS("]");
	if(bt1press==1){
		giorniatt[ctrlmn411][ctrlmn41]=giorniatt[ctrlmn411][ctrlmn41]^1;
		bt1press=0;
	}
	if(bt2press==1){
		menucorr=411;
		bt2press=0;
	}
	if(bt3press==1){
		ctrlmn411++;
		bt3press=0;
	}
	if(bt4press==1){
		ctrlmn411--;
		bt4press=0;
	}
	if(ctrlmn411>7){
		ctrlmn411=1;
	}
	if(ctrlmn411<1){
		ctrlmn411=7;
	}

}
//------------------------------------------------MENU 4.1.2.1 (ora inizio e fine)
//
//inizio [00]:[00]
//fine   [00]:[00]
if(menucorr==4121){
	LCD_PUTS("inizio  ");
	if(orari[1][ctrlmn41]<=9){
		LCD_PUTS("0");
	}
	LCD_PUTUN(orari[1][ctrlmn41]);
	LCD_PUTS(" : ");
	if(orari[2][ctrlmn41]<=9){
		LCD_PUTS("0");
	}
	LCD_PUTUN(orari[2][ctrlmn41]);
	LCD_GOTO(2,1);
	LCD_PUTS("fine    ");
	if(orari[3][ctrlmn41]<=9){
		LCD_PUTS("0");
	}
	LCD_PUTUN(orari[3][ctrlmn41]);
	LCD_PUTS(" : ");
	if(orari[4][ctrlmn41]<=9){
		LCD_PUTS("0");
	}
	LCD_PUTUN(orari[4][ctrlmn41]);
	switch(ctrlmn412){
		case 1:
		LCD_GOTO(1,8);
		LCD_PUTS("[");
		LCD_GOTO(1,11);
		LCD_PUTS("]");
		break;
		case 2:
		LCD_GOTO(1,13);
		LCD_PUTS("[");
		LCD_GOTO(1,16);
		LCD_PUTS("]");
		break;
		case 3:
		LCD_GOTO(2,8);
		LCD_PUTS("[");
		LCD_GOTO(2,11);
		LCD_PUTS("]");
		break;
		case 4:
		LCD_GOTO(2,13);
		LCD_PUTS("[");
		LCD_GOTO(2,16);
		LCD_PUTS("]");
		break;
	}
	
	if(bt1press==1){
		if(ctrlmn412<4){
			ctrlmn412++;
		} else {
			ctrlmn412=1;
		}
		bt1press=0;
	}
	if(bt2press==1){
		menucorr=411;
		bt2press=0;
	}
	if(bt3press==1){
		orari[ctrlmn412][ctrlmn41]++;
		bt3press=0;
	}
	if(bt4press==1){
		orari[ctrlmn412][ctrlmn41]--;
		bt4press=0;
	}

	switch(ctrlmn412){
		case 1:
		case 3:
		if(orari[ctrlmn412][ctrlmn41]<0){
			orari[ctrlmn412][ctrlmn41]=23;
		}
		if(orari[ctrlmn412][ctrlmn41]>23){
			orari[ctrlmn412][ctrlmn41]=0;
		}
		break;
		case 2:
		case 4:
		if(orari[ctrlmn412][ctrlmn41]<0){
			orari[ctrlmn412][ctrlmn41]=59;
		}
		if(orari[ctrlmn412][ctrlmn41]>59){
			orari[ctrlmn412][ctrlmn41]=0;
		}
		break;
	}
}		

//------------------------------------------------MENU 4.1.3.1 (temperatura)
if(menucorr==4131){
	LCD_PUTS(" temperatura");
	LCD_GOTO(2,1);
	LCD_PUTS("Timp= ");
	LCD_PUTUN(temperature[ctrlmn41]);
	bt1press=0;
	if(bt2press==1){
		menucorr=411;
		bt2press=0;
	}
	if(bt3press==1){
		if(temperature[ctrlmn41]<50){
			temperature[ctrlmn41]++;
		}
		bt3press=0;
	}
	if(bt4press==1){
		if(temperature[ctrlmn41]>5){
			temperature[ctrlmn41]--;
		}
		bt4press=0;
	}

}
//------------------------------------------------MENU 5

if(menucorr==5){
	LCD_PUTS(" menu principale");
	LCD_GOTO(2,1);
	LCD_PUTS("  reg. orologio");
	if(bt1press==1){
		menucorr=51;
		bt1press=0;
	}
	if(bt2press==1){
		menucorr=1;
		bt2press=0;
	}
	if(bt3press==1){
		menucorr=4;
		bt3press=0;
	}
	if(bt4press==1){
		menucorr=6;
		bt4press=0;
	}
}

//------------------------------------------------MENU 5.1 (reg.  ORA)
//  reg. orologio
//[00]:[00] [GGG]

if(menucorr==51){
	if(ctrlmn51bis==0){
		orariotemp[2]=minutiint;
		orariotemp[1]=oreint;
		orariotemp[3]=giorniint;
		ctrlmn51bis=1;
	}
	LCD_PUTS("  reg. orologio");
	LCD_GOTO(2,2);
	if(orariotemp[1]<=9){
		LCD_PUTS("0");
	}
	LCD_PUTUN(orariotemp[1]);
	LCD_GOTO(2,5);
	LCD_PUTS(":");
	if(orariotemp[2]<=9){
		LCD_PUTS(" 0");
	} else {
		LCD_PUTS(" ");
	}
	LCD_PUTUN(orariotemp[2]);
	LCD_GOTO(2,12);
	switch(orariotemp[3]){
	case 1:
		LCD_PUTS("Lun");
		break;
	case 2:
		LCD_PUTS("Mar");
		break;
	case 3:
		LCD_PUTS("Mer");
		break;
	case 4:
		LCD_PUTS("Gio");
		break;
	case 5:
		LCD_PUTS("Ven");
		break;
	case 6:
		LCD_PUTS("Sab");
		break;
	case 7:
		LCD_PUTS("Dom");
		break;
	}
	switch(ctrlmn51){
	case 1:
		LCD_GOTO(2,1);
		LCD_PUTS("[");
		LCD_GOTO(2,4);
		LCD_PUTS("]");
		break;
	case 2:
		LCD_GOTO(2,6);
		LCD_PUTS("[");
		LCD_GOTO(2,9);
		LCD_PUTS("]");
		break;
	case 3:
		LCD_GOTO(2,11);
		LCD_PUTS("[");
		LCD_GOTO(2,15);
		LCD_PUTS("]");
		break;
	}
	if(bt1press==1){
		ctrlmn51++;
		bt1press=0;
	}
	if(bt2press==1){
		menucorr=511;
		bt2press=0;
	}
	if(bt3press==1){
		orariotemp[ctrlmn51]++;
		bt3press=0;
	}
	if(bt4press==1){
		orariotemp[ctrlmn51]--;
		bt4press=0;
	}
	if(ctrlmn51>=4){
		ctrlmn51=1;
	}
	if(orariotemp[1]<0){
		orariotemp[1]=23;
	}
	if(orariotemp[1]>23){
		orariotemp[1]=0;
	}
	if(orariotemp[2]<0){
		orariotemp[2]=59;
	}
	if(orariotemp[2]>59){
		orariotemp[2]=0;
	}
	if(orariotemp[3]<1){
		orariotemp[3]=7;
	}
	if(orariotemp[3]>7){
		orariotemp[3]=1;
	}
		
	
	

}

//----------MENU 5.1.1 (convalida impostazione ora)
if(menucorr==511){
	LCD_PUTS("CONFERMARE LA");
	LCD_GOTO(2,1);
	LCD_PUTS("DATA IMPOSTATA?");
	if(bt1press==1){
		ore=orariotemp[1];
		minuti=orariotemp[2];
		giorni=orariotemp[3];
		ctrlmn51bis=0;
		bt1press=0;
		menucorr=5;
	}
	if(bt2press==1){
		menucorr=5;
		ctrlmn51bis=0;
		bt2press=0;
	}

}

//----------MENU 6  (impostazioni)
if(menucorr==6){
	LCD_PUTS(" menu principale");
	LCD_GOTO(2,1);
	LCD_PUTS("  impostazioni");
	if(bt1press==1){
		menucorr=61;
		bt1press=0;
	}
	if(bt2press==1){
		menucorr=1;
		bt2press=0;
	}
	if(bt3press==1){
		menucorr=5;
		bt3press=0;
	}
	if(bt4press==1){
		bt4press=0;
	}
}
//----------MENU 6.1 (avvertenza istruzioni)
if(menucorr==61){
	LCD_PUTS("  leggere le");
	LCD_GOTO(2,1);
	LCD_PUTS("  istruzioni!!");
	if(bt1press==1){
		menucorr=62;
		bt1press=0;
	}
	if(bt2press==1){
		menucorr=1;
		bt2press=0;
	}
	if(bt3press==1){
		bt3press=0;
	}
	if(bt4press==1){
		bt4press=0;
	}
}
//----------MENU 6.2 
if(menucorr==62){
	LCD_PUTS("  impostazioni");
	LCD_GOTO(2,1);
		if(ctrlmn62==1){
		LCD_PUTS("valore scarto");
		}
		if(ctrlmn62==2){
		LCD_PUTS("+/- scarto");
		}
	if(bt1press==1){
		if(ctrlmn62==1){
		menucorr=611;
		}
		if(ctrlmn62==2){
		menucorr=612;
		}
		bt1press=0;
	}
	if(bt2press==1){
		menucorr=1;
		bt2press=0;
	}
	if(bt3press==1){
		if(ctrlmn62<2){
		ctrlmn62++;
		}
		bt3press=0;
	}
	if(bt4press==1){
		if(ctrlmn62>1){
		ctrlmn62--;
		}
		bt4press=0;
	}

}
//----------MENU 6.1.1 (selezione scarto secondi
if(menucorr==611){
	LCD_PUTS("impostazioni sec");
	LCD_GOTO(2,1);
	LCD_PUTS("  secondi ");
	LCD_PUTUN(ctrlmn6);
	if(bt1press==1){
		menucorr=6111;
		bt1press=0;
	}
	if(bt2press==1){
		menucorr=62;
		bt2press=0;
	}
	if(bt3press==1){
		ctrlmn6++;
		bt3press=0;
	}
	if(bt4press==1){
		ctrlmn6--;
		bt4press=0;
	}
	if(ctrlmn6>4){
		ctrlmn6=1;
	}
	if(ctrlmn6<1){
		ctrlmn6=4;
	}
}

//----------MENU 6.1.1.1 (regolazione scarto secondi
if(menucorr==6111){
	LCD_PUTS("sec. ");
	LCD_PUTUN(ctrlmn6);
	LCD_PUTS("(");
	LCD_PUTUN(varsecg[1]);
	LCD_PUTUN(varsecg[2]);
	LCD_PUTUN(varsecg[3]);
	LCD_PUTUN(varsecg[4]);
	LCD_PUTS(")");
	LCD_GOTO(2,1);
	LCD_PUTS("valore= ");
	LCD_PUTUN(varsecg[ctrlmn6]);
	if(bt1press==1){
		menucorr=611;
		bt1press=0;
	}
	if(bt2press==1){
		bt2press=0;
	}
	if(bt3press==1){
		if(varsecg[ctrlmn6]<10){
		varsecg[ctrlmn6]++;
		}
		bt3press=0;
	}
	if(bt4press==1){
		if(varsecg[ctrlmn6]>0){
		varsecg[ctrlmn6]--;
		}
		bt4press=0;
	}
}

//----------MENU 6.1.2 (+/- scarto secondi)
if(menucorr==612){
	LCD_PUTS("+/- scarto sec");
	LCD_GOTO(2,1);
	LCD_PUTS("  scarto ");
	if(menopius==0){
	LCD_PUTS("-");
	} else {
	LCD_PUTS("+");
	}
	if(bt1press==1){
		menucorr=62;
		bt1press=0;
	}
	if(bt2press==1){
		bt2press=0;
	}
	if(bt3press==1){
		menopius=0;
		bt3press=0;
	}
	if(bt4press==1){
		menopius=1;
		bt4press=0;
	}
}


}

}


void interrupt ISR(void)
   {
   if(TMR1IF) // overflow del valore di timer0, un secondo
      {
      TMR1H=0x80; // riscrivo sul timer il valore 0x80
      secondi++; // incremento i secondi
 
      if (secondi==60)	//se i secondi sono a 60,  passato un minuto.
         {
         secondi=0;
         minuti++;
         }
      if (minuti==60)	//se i minuti sono a 60,  passata un'ora
         {
         minuti=0;
         ore++;
         }
      if (ore==24)		//se le ore sono a 24,  passato un giorno
         {
         ore=0;
		 giorni++;
			 if(secondi==10){
			 if(menopius==0){
			 secondi=secondi-varsecg[ctrlsecgvar];		//se menopius  a 0 sottrae se  a 1 somma
			 }
			 if(menopius==1){
			 secondi=secondi+varsecg[ctrlsecgvar];
			 }
				 if(ctrlsecgvar<5){
				 ctrlsecgvar++;
				 } else {
				 ctrlsecgvar=1;
				 }
			 }
         }
	  if (giorni==8)	//se i giorni sono a 8,  passata una settimana
		 {
		 giorni=1;
		 }

	if(retrosec<30){
		retrosec++;
	}


      TMR1IF=0; // azzero il flag di interrupt
      }
   }
